



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>vue中的keep-alive</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">vue中的keep-alive</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-09 08:55:26 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本文转载于：<a href="https://blog.csdn.net/xum222222/article/details/80322532" rel="external nofollow noreferrer">https://blog.csdn.net/xum222222/article/details/80322532</a></p>
<p>转载仅供个人日后学习</p>
<p><a href="https://www.cnblogs.com/jinzhenzong/p/7885643.html" rel="external nofollow noreferrer">https://www.cnblogs.com/jinzhenzong/p/7885643.html</a></p>
<p>keep-alive的作用主要是在组件切换时，保存组件的状态，防止重复渲染引发性能问题。比如：常见的列表页与详情页，当我们在列表页通过滚动鼠标寻找到自己感兴趣的标题时，点进去进入详情页，当浏览完详情页后返回到列表页，此时我们希望返回的列表页不是重新渲染后的列表页，而是我们之前滚动到的位置，keep-alive 就可以帮助我们缓存列表页的状态，实现上述效果。keep-alive起到一个缓存作用，用来保存页面的状态（包括数据、操作等）。</p>
<p>demo实践，感受keep-alive的作用<br />&emsp;&emsp;demo中定义了两个组件，Page1和Page2。并通过路由实现了两个组件之间的切换。在page1页面的输入框中输入一些内容后，切换到page2页面，再从page2重新切换到page1时，通过keep-alive可以实现输入框中的内容保持不变。</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html lang="en"&gt;<br />
&lt;head&gt;<br />
  &lt;meta charset="UTF-8"&gt;<br />
  &lt;meta name="viewport" content="width=device-width, initial-scale=1.0"&gt;<br />
  &lt;meta http-equiv="X-UA-Compatible" content="ie=edge"&gt;<br />
  &lt;title&gt;keep-alive&lt;/title&gt;<br />
&lt;/head&gt;<br />
&lt;body&gt;<br />
  &lt;div id="app"&gt;<br />
    &lt;router-link to="/page1"&gt;page1&lt;/router-link&gt;<br />
    &lt;router-link to="/page2"&gt;page2&lt;/router-link&gt;<br />
    &lt;keep-alive&gt;<br />
      &lt;router-view v-if="$route.meta.keepAlive"&gt;&lt;/router-view&gt;<br />
    &lt;/keep-alive&gt;<br />
    &lt;router-view v-if="!$route.meta.keepAlive"&gt;&lt;/router-view&gt;<br />
  &lt;/div&gt;<br />
  &lt;script src="https://unpkg.com/vue"&gt;&lt;/script&gt;<br />
  &lt;script src="https://unpkg.com/vue-router"&gt;&lt;/script&gt;<br />
  &lt;script&gt;<br />
  const Page1 = Vue.extend({<br />
      template: `&lt;div class="page1"&gt;<br />
        &lt;h1&gt;page1&lt;/h1&gt;<br />
        &lt;input type="text" /&gt;<br />
      &lt;/div&gt;<br />
      `,<br />
    })<br />
  const Page2 = Vue.extend({<br />
    template: `&lt;div class="page2"&gt;<br />
      &lt;h1&gt;page2&lt;/h1&gt;<br />
    &lt;/div&gt;<br />
    `,<br />
  })

  const routes = [<br />
    {<br />
      path: '/page1',<br />
      component: Page1,<br />
      meta: {<br />
        keepAlive: true,<br />
      }<br />
    },<br />
    {<br />
      path: '/page2',<br />
      component: Page2,<br />
      meta: {<br />
        keepAlive: false,<br />
      }<br />
    },<br />
  ]

  const router = new VueRouter({<br />
    routes,<br />
  })

  const app = new Vue({<br />
    router<br />
  }).$mount('#app')<br />
  &lt;/script&gt;<br />
&lt;/body&gt;<br />
&lt;/html&gt;<br />
---------------------</pre>
</div>
<ul><li>代码copy到编辑器中保存为.html文件，用浏览器打开观察结果。</li></ul>
<p>上述demo中，通过在路由时，为组件<code>Page1</code>和<code>Page2</code>设置meta的keepAlive状态来控制组件是否需要缓存。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qw12k87.html">python学习笔记（基础四：模块初识、pyc和PyCodeObject是什么）</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2wo2vq.html">maven阿里云中央仓库</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwlxyr9.html">Merge k Sorted Lists</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qygm5dq.html">jQuery Mobile 中创建按钮</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw77238.html">IE11和传统asp&period;net的兼容问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnkd06q.html">The Automated Testing Handbook 自动化测试手册简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m3wvkq.html">poj 2325 Persistent Numbers （贪心&plus;高精度）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1kr6j8.html">css权威指南（上）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde2l679.html">Create new Android Virtual Device时不能创建</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj1d4k9.html">Mysql 语句汇总（性能篇）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1wormq.html">机器学习笔记&lpar;一&rpar;- from Andrew Ng的教学视频</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kkzr69.html">python学习笔记之11：图像用户界面</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjwxnr8.html">手把手教小白如何用css&plus;js实现页面中图片放大展示效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz5zoe8.html">Input子系统（二）【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwwwgz8.html">ionic3 百度地图插件定位  问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m216g6q.html">JVM总结-java对象的内存布局</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy546v9.html">【JS点滴】声明提前，变量声明提前，函数声明提前，声明提前的先后顺序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2gldz9.html">FragmentStatePagerAdapter和FragmentPagerAdapter区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvezklo9.html">Python Web笔记之高性能网络编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx242208.html">BZOJ 1013 &vert; 一份写了一堆注释的高斯消元题解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxk0vy08.html">ubuntu16&period;04SSH无法连接</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzy3348.html">P1772 &lbrack;ZJOI2006&rsqb;物流运输</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgjxjm8.html">redis的 rdb 和 aof 持久化的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp6n4xq.html">IP通信基础学习第八周</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp6m1zq.html">Numpy 和 Matplotlib库的学习笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2mne6q.html">大佬是怎么思考设计MySQL优化方案的？</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv25vpj9.html">&lbrack;c&sol;c&plus;&plus;&rsqb; programming之路（31）、位运算（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5zdrdq.html">【双目备课】《学习OpenCV第18章》相机模型与标定整编</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj01y79.html">用Python绘制一个感兴趣是数学公式图</a>
			</li>
						<li><a href="https://www.batexi.com/a/93woyxwq.html">MSSQL 漏洞利用与提权</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
